var hostprop = "http://api.xtysw.helian100.cc/";
var PAY_BASE_URL = hostprop;
var BASE_URL = hostprop + "api/";
var DESKTOP_BASE_URL = hostprop + "desktop/";
var STATIC_URL = "http://fengsitech-static.fengsitech.com/xtysw/uploads/image/";
(function(w) {
	// H5 plus事件处理
	var ws = null,
		as = 'slide-in-right',
		at = 300;

	if (w.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}

	// 处理返回事件
	w.back = function(hide) {
		if (w.plus) {
			ws || (ws = plus.webview.currentWebview());
			if (hide || ws.preate) {
				ws.hide('auto', at);
			} else {
				ws.close('auto', at);
			}
		} else if (history.length > 1) {
			history.back();
		} else {
			w.close();
		}
	};

	// 处理点击事件
	var openw = null,
		waiting = null;
	/**
	 * 打开新窗口
	 * @param {URIString} id : 要打开页面url
	 * @param {boolean} wa : 是否显示等待框
	 * @param {boolean} ns : 是否不自动显示
	 * @param {map} extras : 传递给新页面的额外参数
	 */
	w.changePage = function(id, wa, ns, extras) {
		if (openw) { //避免多次打开同一个页面
			openw.show('slide-in-right', 300);
			return null;
		}

		if (w.plus) {
			wa && (waiting = plus.nativeUI.showWaiting());
			var pre = ''; //'http://192.168.1.178:8080/h5/';
			openw = plus.webview.create(pre + id, id, {
				scrollIndicator: 'none',
				scalable: false,
				//bounce: 'vertical',
			}, extras);
			ns || openw.addEventListener('loaded', function() { //页面加载完成后才显示
				//		setTimeout(function(){//延后显示可避免低端机上动画时白屏
				openw.show(as, at);
				closeWaiting();
				//		},200);
			}, false);
			openw.addEventListener('close', function() { //页面关闭后可再次打开
				openw = null;
			}, false);

			return openw;
		} else {
			w.open(id);
		}
		return null;
	};

	w.pullfreshPage = function(header, content, title, extras) {
		var headerWebview = plus.webview.getWebviewById(header);
		if (!headerWebview) {
			headerWebview = mui.preload({
				url: header,
				id: header,
				styles: {},
				extras: {
					mType: "sub",
				},
			});

			headerWebview.addEventListener('loaded', function() {
				mui.fire(headerWebview, 'updateHeader', {
					title: title
				});
			});
		} else {
			mui.fire(headerWebview, 'updateHeader', {
				title: title
			});
		}

		var contentWebview = plus.webview.getWebviewById(content);
		if (!contentWebview) {
			if (content == 'transactions_list.html' || content == 'favorite_list.html') {
				contentWebview = mui.preload({
					url: content,
					id: content,
					styles: {
						top: '95px',
						bottom: '0px',
					},
					extras: extras,
				});
			} else if (content == 'comments_list.html') {
				contentWebview = mui.preload({
					url: content,
					id: content,
					styles: {
						top: '45px',
						bottom: '54px',
					},
					extras: extras,
				});
			} else if (content == "shopping_cart.html") {
				contentWebview = mui.preload({
					url: content,
					id: content,
					styles: {
						top: '45px',
						bottom: '54px',
					},
					extras: extras,
				});
			} else {
				contentWebview = mui.preload({
					url: content,
					id: content,
					styles: {
						top: '45px',
						bottom: '0px',
					},
					extras: extras,
				});
			}

			contentWebview.addEventListener('loaded', function() {
				mui.fire(contentWebview, 'updateContent', extras);
				setTimeout(function() {
					contentWebview.show();
				}, 300);
			});
			headerWebview.append(contentWebview);
		} else {
			mui.fire(contentWebview, 'updateContent', extras);
		}

		contentWebview.show();
		headerWebview.show('slide-in-right', 300);
	};

	/**
	 * 关闭等待框
	 */
	w.closeWaiting = function() {
		waiting && waiting.close();
		waiting = null;
	};

	function plusReady() {
		ws = plus.webview.currentWebview();
	}
})(window);

(function($) {
	//全局配置(通常所有页面引用该配置，特殊页面使用mui.init({})来覆盖全局配置)
	$.initGlobal({
		swipeBack: true
	});

	var first = null;
	var back = $.back;
	$.back = function() {
		var current = plus.webview.currentWebview();
		if (current.mType == 'main') { //模板主页面
			//首次按键，提示‘再按一次退出应用’
			if (!first) {
				first = new Date().getTime();
				mui.toast('再按一次退出应用');
				setTimeout(function() {
					first = null;
				}, 1000);
			} else {
				if (new Date().getTime() - first < 1000) {
					plus.runtime.quit();
				}
			}
		} else if (current.mType == 'sub') {
			if ($.targets._popover) {
				$($.targets._popover).popover('hide');
			} else {
				current.parent().evalJS('mui&&mui.back();');
			}
		} else {
			back();
		}
	};
})(mui);

var getState = function() {
	var stateText = localStorage.getItem('$state') || "{}";
	return JSON.parse(stateText);
};

var setState = function(state) {
	state = state || {};
	localStorage.setItem('$state', JSON.stringify(state));
};

var setSettings = function(settings) {
	settings = settings || {};
	if (!settings) {
		localStorage.clear();
	}
	localStorage.setItem('$settings', JSON.stringify(settings));
}

var getSettings = function() {
	var settingsText = localStorage.getItem('$settings') || "{}";
	return JSON.parse(settingsText);
}
var channel = null;
/**
 * 支付宝接口.
 * @param {String} w : 等待状态;
 * @param {int} objId : 项目ID 例:产品id 课程id 医生id 等等...
 * @param {int} count : 购买数量总数
 * @param {URLString} uri : 支付宝后台接口地址. 例:'http://demo.wiaapp.cn/alipay/productstradeactions/payfrommui'
 * @param {int} pacs_id : 检查报告ID.
 * @param {int} hospital_code : 医院编号.
 * @param {String} token : 用户指纹
 * @param {int} tran_id : 订单ID
 */
var pay_interface = function(w, objId, uri, create, transaction_id, address_id, from, ch) {
	if (w) {
		return;
	}
	plus.payment.getChannels(function(channels) {
		for (var i in channels) {
			if (channels[i].id == ch) {
				channel = channels[i];
				break;
			}
		}
	}, function(e) {
		plus.nativeUI.alert("获取支付通道失败: " + e.message, function() {
			mui.back();
		}, "支付");
	});
	w = plus.nativeUI.showWaiting();
	var url = uri + "?data=" + objId + "&token=" + getState().token + "&iscreate=" + create + "&transaction_id=" + transaction_id + "&address_id=" + address_id;
	var xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function() {
		switch (xhr.readyState) {
			case 4:
				w.close();
				w = null;
				if (xhr.status == 200) {
					plus.payment.request(channel, xhr.responseText, function(result) {
						var opener = plus.webview.getWebviewById(plus.webview.currentWebview().opener().id).parent().id
						var objectView = plus.webview.getWebviewById(plus.webview.currentWebview().opener().id).opener();
						plus.nativeUI.toast("支付成功!");
						console.log("from:  "+from)
						if (from != "product") {
							mui.post(BASE_URL + 'clean_up_shopping_cart', {
								token: getState().token
							}, function(data) {
								mui.fire(plus.webview.getWebviewById('shopping_cart.html'), 'updateContent');
							});
						}
						setTimeout(function() {
							if (objectView.id == "transactions_list.html") {
								mui.fire(objectView, "upContentList", {
									whereGoTo: 'indent',
									btn: -1
								});
								plus.webview.close(plus.webview.getWebviewById(opener), "auto", 200);
							}
							mui.back();
						}, 300);
					}, function(error) {
						if (error.code == -100) {
							console.log(JSON.stringify(error));
							mui.back();
							plus.nativeUI.alert("您取消了支付");
						} else {
							console.log(JSON.stringify(error));
						};
					});
				} else {
					plus.nativeUI.alert("生成订单失败! " + xhr.status);
				}
				break;
		}
	}
	xhr.open('GET', url);
	xhr.send();
}

//时间格式化函数.
Date.prototype.pattern = function(fmt) {
		var o = {
			"M+": this.getMonth() + 1, //月份         
			"d+": this.getDate(), //日         
			"h+": this.getHours() % 12 == 0 ? 12 : this.getHours() % 12, //小时         
			"H+": this.getHours(), //小时         
			"m+": this.getMinutes(), //分         
			"s+": this.getSeconds(), //秒         
			"q+": Math.floor((this.getMonth() + 3) / 3), //季度         
			"S": this.getMilliseconds() //毫秒         
		};
		var week = {
			"0": "/u65e5",
			"1": "/u4e00",
			"2": "/u4e8c",
			"3": "/u4e09",
			"4": "/u56db",
			"5": "/u4e94",
			"6": "/u516d"
		};
		if (/(y+)/.test(fmt)) {
			fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
		}
		if (/(E+)/.test(fmt)) {
			fmt = fmt.replace(RegExp.$1, ((RegExp.$1.length > 1) ? (RegExp.$1.length > 2 ? "/u661f/u671f" : "/u5468") : "") + week[this.getDay() + ""]);
		}
		for (var k in o) {
			if (new RegExp("(" + k + ")").test(fmt)) {
				fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
			}
		}
		return fmt;
	}
	/*将图片压缩转换为base64字符串函数*/
function reSizeImg(imgURL, uploadFunction) {
	// 兼容以“file:”开头的情况
	var ws = plus.nativeUI.showWaiting("上传中请稍等...", {
		back: "none"
	});
	if (0 != imgURL.toString().indexOf("file://")) {
		imgURL = "file://" + imgURL;
	}
	var _img_ = new Image();
	_img_.src = imgURL; // 传过来的图片路径在这里用。
	//	_img_.onclick = function() {//图片点击钓鱼本地相册事件
	//		plus.runtime.openFile(imgURL);
	//	};
	_img_.onload = function() {
		var tmph = _img_.height;
		var tmpw = _img_.width;
		var isHengTu = tmpw > tmph;
		var max = Math.max(tmpw, tmph);
		var min = Math.min(tmpw, tmph);
		var bili = min / max;
		if (max > 200) {
			max = 200;
			min = Math.floor(bili * max);
		}
		tmph = isHengTu ? min : max;
		tmpw = isHengTu ? max : min;
		plus.io.resolveLocalFileSystemURL(imgURL, function(entry) {
				entry.file(function(file) {
					canvasResize(file, {
						width: tmpw,
						height: tmph,
						crop: false,
						quality: 50, //压缩质量
						rotate: 0,
						callback: function(data, width, height) {
							//							console.log('图片的宽:  ' + width + "\n图片的高:  " + height);
							//							console.log(JSON.stringify(data).length)
							uploadFunction(data.split(',')[1]);
							ws.close();
						}
					});
				});
			},
			function(e) {
				plus.toast(e.message);
				ws.close();
			});
	};
};
//----------------------------------------------------自定MAP集合--------------------------------------------------
/*  
 * MAP对象，实现MAP功能  
 *  
 * 接口：  
 * size()     获取MAP元素个数  
 * isEmpty()    判断MAP是否为空  
 * clear()     删除MAP所有元素  
 * put(key, value)   向MAP中增加元素（key, value)   
 * remove(key)    删除指定KEY的元素，成功返回True，失败返回False  
 * get(key)    获取指定KEY的元素值VALUE，失败返回NULL  
 * element(index)   获取指定索引的元素（使用element.key，element.value获取KEY和VALUE），失败返回NULL  
 * containsKey(key)  判断MAP中是否含有指定KEY的元素  
 * containsValue(value) 判断MAP中是否含有指定VALUE的元素  
 * values()    获取MAP中所有VALUE的数组（ARRAY）  
 * keys()     获取MAP中所有KEY的数组（ARRAY）  
 *  
 * 例子：  
 * var map = new Map();  
 *  
 * map.put("key", "value");  
 * var val = map.get("key")  
 * ……  
 *  
 */
function Map() {
	var bln = false;
	this.elements = new Array();

	//获取MAP元素个数   
	this.size = function() {
		return this.elements.length;
	}

	//判断MAP是否为空   
	this.isEmpty = function() {
		return (this.elements.length < 1);
	}

	//删除MAP所有元素   
	this.clear = function() {
		this.elements = new Array();
	}

	//向MAP中增加元素（key, value)    
	this.put = function(_key, _value) {
		this.elements.push({
			key: _key,
			value: _value
		});
	}

	//删除指定KEY的元素，成功返回True，失败返回False   
	this.remove = function(_key) {
		try {
			for (i = 0; i < this.elements.length; i++) {
				if (this.elements[i].key == _key) {
					this.elements.splice(i, 1);
					return true;
				}
			}
		} catch (e) {
			bln = false;
		}
		return bln;
	}

	//获取指定KEY的元素值VALUE，失败返回NULL   
	this.get = function(_key) {
		try {
			for (i = 0; i < this.elements.length; i++) {
				if (this.elements[i].key == _key) {
					return this.elements[i].value;
				}
			}
		} catch (e) {
			return null;
		}
	}

	this.getIndex = function(_key) {
		try {
			var i = 0;
			for (i = 0; i < this.elements.length; i++) {
				if (this.elements[i].key == _key) {
					return i;
				}
			}
		} catch (e) {
			return null;
		}
	}

	//获取指定索引的元素（使用element.key，element.value获取KEY和VALUE），失败返回NULL   
	this.element = function(_index) {
		if (_index < 0 || _index >= this.elements.length) {
			return null;
		}
		return this.elements[_index];
	}

	//判断MAP中是否含有指定KEY的元素   
	this.containsKey = function(_key) {
		varbln = false;
		try {
			for (i = 0; i < this.elements.length; i++) {
				if (this.elements[i].key == _key) {
					bln = true;
				}
			}
		} catch (e) {
			bln = false;
		}
		return bln;
	}

	//判断MAP中是否含有指定VALUE的元素   
	this.containsValue = function(_value) {
		var bln = false;
		try {
			for (i = 0; i < this.elements.length; i++) {
				if (this.elements[i].value == _value) {
					bln = true;
				}
			}
		} catch (e) {
			bln = false;
		}
		return bln;
	}

	//获取MAP中所有VALUE的数组（ARRAY）   
	this.values = function() {
		var arr = new Array();
		for (i = 0; i < this.elements.length; i++) {
			arr.push(this.elements[i].value);
		}
		return arr;
	}

	//获取MAP中所有KEY的数组（ARRAY）   
	this.keys = function() {
		var arr = new Array();
		for (i = 0; i < this.elements.length; i++) {
			arr.push(this.elements[i].key);
		}
		return arr;
	}
}
