mui.init();
var styleType = "p5-address-radio-div",styleType2 = "p5-address-delete-div";
		var get_address = function() {
			var ws = plus.nativeUI.showWaiting();
			mui.ajax(BASE_URL + 'address', {
				data: {
					token: getState().token
				},
				dataType: 'json',
				type: 'get',
				timeout: '10000',
				success: function(data) {
					var table = document.getElementById('p5-address-table');
					if (mui.os.ios) {
						if (document.querySelector("#p5-address-table").clientWidth <= 320) {
							styleType = "p5-address-radio-div-ios";
							styleType2 = "p5-address-delete-div-ios";
						}
					}
					if (data != undefined) {
						if (data.length > 0) {
							document.getElementById('p5-address-div').classList.add('mui-hidden');
							document.getElementById('p5-address-submit').classList.remove('mui-hidden');
							for (var i = 0; i < data.length; i++) {
								var li = document.createElement('li');
								li.className = 'mui-table-view-cell';
								li.id = 'add' + i;
								li.innerHTML = '<div id="p5-address">' +
									'<label>' + data[i].address_name + '</label>' +
									'<span>' + data[i].cellphone + '</span>' +
									'<p class="mui-ellipsis">' + data[i].address + '</p>' +
									'</div>';
								var li2 = document.createElement('li');
								li2.className = 'mui-table-view-cell p5-li-after';
								li2.id = "one_" + data[i].address_id;
								li2.innerHTML = '<div class="mui-input-row mui-radio mui-left '+styleType+'">' +
									'<label class="p5-address-label" style="color: ' + (data[i].is_default == 1 ? '#29BE17' : '#D4DBED') + ';">' + (data[i].is_default == 1 ? '当前使用' : '使用这个地址') + '</label>' +
									'<input name="radio1" value="' + data[i].address_id + '" type="radio"  ' + (data[i].is_default == 1 ? 'checked' : '') + '>' +
									'</div>' +
									'<div class="'+styleType2+'" id="delete_' + data[i].address_id + '">' +
									'<span class="mui-btn mui-icon mui-icon-compose" id="redact_' + data[i].address_id + '">&nbsp;编辑</span>' +
									'<span class="mui-btn mui-icon mui-icon-trash" id="delete_' + data[i].address_id + '">&nbsp;删除</span>' +
									'</div>';
								var div = document.createElement('div');
								div.className = 'p5-address-partition';
								div.id = "cut-off_rule" + data[i].address_id;
								table.insertBefore(li, table.firstChild);
								table.insertBefore(li2, li.nextSibling);
								table.insertBefore(div, li2.nextSibling);
							}
						} else {
							document.getElementById('p5-address-div').classList.remove('mui-hidden');
							document.getElementById('p5-address-submit').classList.add('mui-hidden');
						}
					}
					ws.close()
				},
				error: function(xhr, type, errorThrown) {
					ws.close()
					error_code_handle(xhr, type, errorThrown)
				}
			});
		}
		mui.plusReady(function() {
			var from = plus.webview.currentWebview().from;
			setTimeout(get_address(), 50);
		});
		document.getElementById('p5-address-submit').addEventListener('tap', function() {
			var from = plus.webview.currentWebview().from;
			var radios = document.querySelectorAll("#p5-address-table input");
			var labels = document.querySelectorAll("#p5-address-table .p5-address-label");
			for (var i = 0; i < radios.length; i++) {
				labels[i].style.color = (radios[i].checked == true ? '#29BE17' : '#D4DBED');
				labels[i].innerHTML = (radios[i].checked == true ? '当前使用' : '使用这个地址');
				if (radios[i].checked == true) {
					if (from == "pay_from") {
						mui.fire(plus.webview.getWebviewById('confirm_payment.html'), 'update_address', {
							address_id: radios[i].value
						});
						plus.webview.close(plus.webview.currentWebview(), 'auto', 200);
					} else {
						mui.post(BASE_URL + "update_address", {
							token: getState().token,
							address_id: radios[i].value,
							is_default: 1
						}, function(data) {
							mui.toast("默认地址更新成功");
							plus.webview.close(plus.webview.currentWebview(),"slide-out-right",300);
						});
					}
				}
			}
		});
		
		document.getElementById('p5-delivery-save').addEventListener('tap', function(){
			changePage('delivery_append.html',true,false);
		});
		
		mui('#p5-address-table').on('tap', '.mui-icon-compose', function(e) {
			address_Id = this.id;
			changePage('redact_address.html', true, false, {
				address_Id: address_Id.split('_')[1]
			});
		});
		mui('#p5-address-table').on('tap', '.mui-icon-trash', function(e) {
			address_Id = this.id;
			var thisNode = document.querySelector("#" + address_Id).parentNode;
			var prevSb = document.querySelector("#" + thisNode.id).previousSibling;
			var nextSb = document.querySelector("#" + thisNode.id).nextSibling;
			var thisObj = document.querySelector("#"+thisNode.id+" input");
			if (!thisObj.checked) {
				if (confirm('确定要删除改地址吗?') == 1) {
				var ws = plus.nativeUI.showWaiting();
				mui.ajax(BASE_URL + "delete_address", {
					data: {
						token: getState().token,
						address_id: address_Id.split('_')[1],
					},
					type: 'post',
					dataType: 'json',
					timeout: 15000,
					success: function(data) {
						document.querySelector("#" + thisNode.id).remove();
						document.querySelector('#' + prevSb.id).remove();
						document.querySelector("#" + nextSb.id).remove();
						mui.toast("删除成功!");
						ws.close();
					},
					error: function(xhr, type, errorThrown) {
						mui.toast("删除失败!");
						ws.close();
						error_code_handle(xhr, type, errorThrown)
					}
				});
			}
			}else{
				mui.toast("请选择其它地址后在删除该收货地址.")
			}
		});
		window.addEventListener('updateAddress', function(e) {
			document.getElementById('p5-address-table').innerHTML = '';
			get_address();
		});