document.getElementById('p5-address-append').addEventListener('tap', function() {
	var address = document.getElementById('p5-delivery-input').value;
	var sname = document.getElementById('p5-delivery-name').value;
	var sphone = document.getElementById('p5-delivery-phone').value;
	var zipCode = document.getElementById('p5-delivery-zip-code').value;
	var re = /^[0-9][0-9]{5}$/;
	if (sname.trim() != '') {
		if (sphone.trim() != '') {
			if (Regexs.allphpne.test(sphone)) {
				if (re.test(zipCode) && zipCode.trim() != '') {
					if (address.trim() != '') {
						var ws = plus.nativeUI.showWaiting();
						mui.ajax(BASE_URL + 'add_address', {
							data: {
								token: getState().token,
								name: sname,
								cellphone: sphone,
								address: address,
								postcode: zipCode,
								is_default: 1,
							},
							dataType: 'json',
							type: 'post',
							timeout: '10000',
							success: function(data) {
								mui.toast("设置成功");
								parentContentView = plus.webview.currentWebview().opener();
								mui.fire(parentContentView, 'updateAddress');
								mui.fire(parentContentView, 'upDateUserInfo');
								setTimeout(function(e) {
									ws.close();
									plus.webview.close(plus.webview.currentWebview(), 'slide-out-right', 300)
								}, 1000)
							},
							error: function(xhr, type, errorThrown) {
								ws.close();
								error_code_handle(xhr, type, errorThrown)
							}
						})
					} else {
						mui.toast('地址不能为空');
					}
				} else {
					mui.toast("邮编格式不正确！")
				}
			} else {
				mui.toast("请输入正确的手机号码..");
			}
		} else {
			mui.toast("请填写联系电话..");
		}
	} else {
		mui.toast("请填写收货人姓名..");
	}
});