var page = 1,
	offset = 1,
	longitude = 0,
	latitude = 0;
var offon = true;
var keywords = "",
	category_id = 0;
var styles = "mui-media-body";
var styles2 = "info_box";
var styles3 = "keyword_filter_box";
var listType = "listType";
var listType2 = "p5-recently-distancediv";
var listType3 = "p5-recently-money";
var imgType = "imgType";
var pushResetStyle = "";
//上拉加载 
var getUpProductsList = function() {
	mui.ajax(BASE_URL + "products", {
		data: {
			keywords: keywords,
			category_id: category_id,
			page: page,
			latitude: latitude,
			longitude: longitude
		},
		type: "get",
		dataType: "json",
		timeout: 15000,
		success: function(data) {
			var table = document.body.querySelector('#p5-search-list-ul');
			if (mui.os.ios) {
				if (document.querySelector("#pullrefresh").clientWidth <= 320) {
					styles = "mui-media-body-ios";
					styles2 = "info_box-ios";
					styles3 = "keyword_filter_box_ios";
					listType = "listType-ios";
					listType2 = "p5-recently-distancediv-ios";
					listType3 = "p5-recently-money-ios";
					imgType = "imgType-ios";
				}
			}
			if (offon) {
				pushResetStyle = "' + styles + ' mui-ellipsis"; // mui-icon iconfont icon-untitled101 
			} else {
				pushResetStyle = "";
			}
			for (var i = 0; i < data.length; i++) {
				var keywords = data[i].keywords;
				var buttons = '';
				var reg = new RegExp("，", "g");
				if (null != keywords && "" != keywords) {
					if (-1 != keywords.indexOf(',') || -1 != keywords.indexOf('，')) {
						keywords = keywords.replace(reg, ',');
						keywords = keywords.split(',');
						for (var k = 0; k < keywords.length; k++) {
							buttons += '<button>' + keywords[k] + '</button>';
						}
					} else {
						buttons = '<button>' + keywords + '</button>';
					}
				}

				var li = document.createElement('li');
				li.className = 'mui-table-view-cell '+ listType;
				li.style.paddingBottom = "0px";
				li.id = 'product_' + data[i].id;
				li.name = data[i].swipeshow_id;
				li.innerHTML = '<img width="110px" height="110px" class="'+ imgType +'" src="data:image/jpeg;base64,' + data[i].thumbnail + '"/>' +
					'<div class="' + pushResetStyle + '" id="'+ styles2 +'">' +
					'<span class="mui-ellipsis-2 p5-recently-name">' + data[i].name + '</span>' +
					'<p class="mui-ellipsis-2 p5-recently-keywords">' +
					buttons +  
					'</p>' +
					'<span class="'+ listType3 +'">￥' + data[i].price + '</span>' +
					'<p id="li_icon" class="mui-icon iconfont icon-untitled101"></p>' +
					'</div>' +
					'<div id="keyword_filter_box" class="'+ styles3 +'" style="font-size: 14px; color: #333;">' +
					'<span id="p5-recently-favorite-span">' +
					'<label>&nbsp;&nbsp;收藏:&nbsp;</label><span>' + data[i].favorite_count + '</span>' +
					'<label>&nbsp;&nbsp;评论:&nbsp;</label><span>' + data[i].comment_count + '</span>' +
					'</span>' +
					'<span class="'+ listType2 +'">' +
					'<span class="p5-recently-distance">' + data[i].distance + '</span>' +
					'<span class="mui-icon iconfont icon-unie650 p5-recently-distance-svg"></span>' +
					'</span>' +
					'</div>';
				table.appendChild(li);
				//刷新offset
				if (data[i].id > offset) {
					offset = data[i].id;
				}
			}
			if (data.length == 10) {
				page++;
				mui('#pullrefresh').pullRefresh().refresh(true);
				mui('#pullrefresh').pullRefresh().endPullupToRefresh()
			} else {
				mui('#pullrefresh').pullRefresh().endPullupToRefresh(true)
			}
		},
		error: function(xhr, type, errorThrown) {
			error_code_handle(xhr, type, errorThrown);
		}
	})
}
var getDownProductsList = function() {
	mui.ajax(BASE_URL + "products", {
		data: {
			keywords: keywords,
			category_id: category_id,
			offset: offset,
			latitude: latitude,
			longitude: longitude
		},
		type: "get",
		dataType: "json",
		timeout: 15000,
		success: function(data) {
			var table = document.body.querySelector('#p5-search-list-ul');
			if (mui.os.ios) {
				if (document.querySelector("#pullrefresh").clientWidth <= 320) {
					styles = "mui-media-body-ios";
					styles2 = "info_box-ios";
					styles3 = "keyword_filter_box_ios";
					listType = "listType-ios";
					listType2 = "p5-recently-distancediv-ios";
					listType3 = "p5-recently-money-ios";
					imgType = "imgType-ios";
				}
			}
			if (offon) {
				pushResetStyle = "' + styles + ' mui-ellipsis";
			} else {
				pushResetStyle = "";
			}
			for (var i = data.length; i > 0; i--) {
				var keywords = data[i - 1].keywords;
				var buttons = '';
				var reg = new RegExp("，", "g");
				if (null != keywords && "" != keywords) {
					if (-1 != keywords.indexOf(',') || -1 != keywords.indexOf('，')) {
						keywords = keywords.replace(reg, ',');
						keywords = keywords.split(',');
						for (var k = 0; k < keywords.length; k++) {
							buttons += '<button>' + keywords[k] + '</button>';
						}
					} else {
						buttons = '<button>' + keywords + '</button>';
					}
				}

				var li = document.createElement('li');
				li.className = 'mui-table-view-cell '+ listType;
				li.style.paddingBottom = "0px";
				li.id = 'product_' + data[i - 1].id;
				li.name = data[i - 1].swipeshow_id;
				li.innerHTML = '<img width="110px" height="110px" class="'+ imgType +'" src="data:image/jpeg;base64,' + data[i - 1].thumbnail + '"/>' +
					'<div class="' + pushResetStyle + '" id="'+ styles2 +'">' +
					'<span class="mui-ellipsis-2 p5-recently-name">' + data[i - 1].name + '</span>' +
					'<p class="mui-ellipsis-2 p5-recently-keywords">' + buttons + '</p>' +
					'<span class="'+ listType3 +'">￥' + data[i - 1].price + '</span>' +
					'<p id="li_icon" class="mui-icon iconfont icon-untitled101"></p>' +
					'</div>' +
					'<div id="keyword_filter_box" class="'+ styles3 +'" style="font-size: 14px; color: #333;">' +
					'<span id="p5-recently-favorite-span">' +
					'<label>&nbsp;&nbsp;收藏:&nbsp;</label><span>' + data[i - 1].favorite_count + '</span>' +
					'<label>&nbsp;&nbsp;评论:&nbsp;</label><span>' + data[i - 1].comment_count + '</span>' +
					'</span>' +
					'<span class="'+ listType2 +'">' +
					'<span class="p5-recently-distance">' + data[i - 1].distance + '</span>' +
					'<span class="mui-icon iconfont icon-unie650 p5-recently-distance-svg"></span>' +
					'</span>' +
					'</div>';

				table.insertBefore(li, table.firstChild); //icon-untitled104
				//刷新offset
				if (data[i - 1].id > offset) {
					offset = data[i - 1].id;
				}
			}
			mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
		},
		error: function(xhr, type, errorThrown) {
			error_code_handle(xhr, type, errorThrown);
		}
	})
}
mui.init({
	swipeBack: false,
	pullRefresh: {
		container: '#pullrefresh',
		up: {
			callback: getUpProductsList,
		},
		down: {
			callback: getDownProductsList,
		}
	}
});
window.addEventListener("DOMContentLoaded", function() {
	mui.plusReady(function() {
		mui('#p5-search-list-ul').on('tap', 'li', function() {
			var object_id = this.id
			var classifyName = this.querySelector(".p5-recently-name").innerText;
			pullfreshPage('product_details_frame.html', 'product_details.html', classifyName, {
				object_id: object_id,
				swipeshow_id: this.name
			})
		});
		window.addEventListener("showOrderList", function(e) {
			var ws = plus.nativeUI.showWaiting("",{back: "none"});
			var showAndHidden = document.querySelector("#order_ascAdesc");
			var showAndHiddenFilter = document.querySelector("#type_filter");
			var links = document.querySelectorAll("head link");
			var head = document.querySelector("head");
			var divs = document.querySelectorAll("#p5-search-list-ul div[id*=info_box]");
			var lis = document.body.querySelectorAll('#p5-search-list-ul li');
			var table = document.querySelector("#p5-search-list-ul")
			if (e.detail.orderFun == "排序") {
				showAndHiddenFilter.classList.add("mui-hidden");
				if (showAndHidden.classList != "") {
					showAndHidden.classList.remove("mui-hidden");
				} else {
					showAndHidden.classList.add("mui-hidden");
				}
			} else if (e.detail.orderFun == "筛选") {
				showAndHidden.classList.add("mui-hidden");
				if (showAndHiddenFilter.classList != "") {
					showAndHiddenFilter.classList.remove("mui-hidden");
				} else {
					showAndHiddenFilter.classList.add("mui-hidden");
				}
			} else {
				showAndHiddenFilter.classList.add("mui-hidden");
				showAndHidden.classList.add("mui-hidden");
				if (offon) {
					var addLink = document.createElement("link");
					for (var a = 0; a < divs.length; a++) {
						divs[a].removeAttribute("class")
					}
					for (var i = 0; i < links.length; i++) {
						var href = plus.io.convertLocalFileSystemURL(links[i].href);
						if (href.split("/")[href.split("/").length - 1] != "mui.min.css" && href.split("/")[href.split("/").length - 1] != "iconfont.css" && href.split("/")[href.split("/").length - 1] != "style_unified.css" && offon) {
							links[i].remove();
							addLink.rel = "stylesheet";
							addLink.type = "text/css";
							addLink.href = "css/resetList.css";
							head.appendChild(addLink);
							mui.fire(plus.webview.getLaunchWebview(), "resetIcon", {
								type: "方图"
							})
							for (var v = 0; v < lis.length; v++) {
								table.appendChild(lis[v])
							}
							offon = false;
						}
					}
				} else {
					var addLink = document.createElement("link");
					for (var c = 0; c < links.length; c++) {
						var href = plus.io.convertLocalFileSystemURL(links[c].href);
						if (href.split("/")[href.split("/").length - 1] != "mui.min.css" && href.split("/")[href.split("/").length - 1] != "iconfont.css" && href.split("/")[href.split("/").length - 1] != "style_unified.css" && !offon) {
							links[c].remove();
						}
					}
					addLink.rel = "stylesheet";
					addLink.type = "text/css";
					addLink.href = "css/search.css";
					head.appendChild(addLink);
					mui.fire(plus.webview.getLaunchWebview(), "resetIcon", {
						type: "条图"
					})
					offon = true;
				}
			}
			ws.close()
		});
		//排序函数.
		mui("#order_ascAdesc").on("tap", "p", function(e) {
			var ws = plus.nativeUI.showWaiting("",{back: "none"});
			var showAndHidden = document.querySelector("#order_ascAdesc");
			var table = document.querySelector("#p5-search-list-ul")
			var moneys = new Array();
			var lis = document.body.querySelectorAll('#p5-search-list-ul li');
			var product_moneys = document.body.querySelectorAll('#p5-search-list-ul li span[class*=p5-recently-money]');
			var distances = document.querySelectorAll("#p5-search-list-ul #keyword_filter_box .p5-recently-distance");
			showAndHidden.classList.add("mui-hidden");
			if (this.innerText == "价格由低到高排序") {
				//获取所有产品价格并装入数组
				for (var i = 0; i < product_moneys.length; i++) {
					moneys.push(parseFloat(product_moneys[i].innerText.substring(1, product_moneys[i].innerText.length)));
				}
				for (var i = 0; i < OrderASC(moneys).length; i++) {
					for (var y = 0; y < product_moneys.length; y++) {
						if (OrderASC(moneys)[i] == product_moneys[y].innerText.substring(1, product_moneys[y].innerText.length)) {
							table.appendChild(lis[y]);
						}
					}
				}
			} else if (this.innerText == "价格由高到低排序") {
				//获取所有产品价格并装入数组
				for (var i = 0; i < product_moneys.length; i++) {
					moneys.push(parseFloat(product_moneys[i].innerText.substring(1, product_moneys[i].innerText.length)));
				}
				for (var f = 0; f < OrderDesc(moneys).length; f++) {
					for (var e = 0; e < product_moneys.length; e++) {
						if (OrderDesc(moneys)[f] == product_moneys[e].innerText.substring(1, product_moneys[e].innerText.length)) {
							table.appendChild(lis[e]);
						}
					}
				}
			} else {
				function sortNumber(a, b) {
					return a - b
				}
				//距离排序
				for (var d = 0; d < distances.length; d++) {
					if (distances[d].innerText.split(" ")[1] == "千米") {
						moneys.push(distances[d].innerText.split(" ")[0].replace(".", "") + "0");
					} else {
						moneys.push(distances[d].innerText.split(" ")[0]);
					}
				}
				var Asc = moneys.sort(sortNumber);
				for (var i = 0; i < Asc.length; i++) {
					for (var y = 0; y < distances.length; y++) {
						if (Asc[i] == (distances[y].innerText.split(" ")[1] == "千米" ? distances[y].innerText.split(" ")[0].replace(".", "") + "0" : distances[y].innerText.split(" ")[0])) {
							table.appendChild(lis[y]);
						}
					}
				}
			}
			ws.close();
		});
		mui("#type_filter").on("tap", "a", function(e) {
			var showAndHiddenFilter = document.querySelector("#type_filter");
			document.body.querySelector('#p5-search-list-ul').innerHTML = "";
			category_id = this.getAttribute("value");
			page = 1, offset = 1;
			showAndHiddenFilter.classList.add("mui-hidden");
			mui('#pullrefresh').pullRefresh().pullupLoading();
		});
		var OrderASC = function(arr) {
			var i = arr.length,
				j;
			var tempExchangVal;
			while (i > 0) {
				for (j = 0; j < i - 1; j++) {
					if (arr[j] > arr[j + 1]) {
						tempExchangVal = arr[j];
						arr[j] = arr[j + 1];
						arr[j + 1] = tempExchangVal;
					}
				}
				i--;
			}
			return arr;
		};
		var OrderDesc = function(arr) {
			var i = arr.length,
				j;
			var tempExchangVal;
			while (i > 0) {
				for (j = 0; j < i + 1; j++) {
					if (arr[j] > arr[j - 1]) {
						tempExchangVal = arr[j];
						arr[j] = arr[j - 1];
						arr[j - 1] = tempExchangVal;
					}
				}
				i--;
			}
			return arr;
		};
		
		var state = getState();
			var currentPosition = plus.geolocation.getCurrentPosition(function(p) {
				state.Lat = p.coords.latitude;
				state.Lon = p.coords.longitude;
				setState(state);
				latitude = p.coords.latitude;
				longitude = p.coords.longitude;
				setTimeout(function() {
					mui('#pullrefresh').pullRefresh().pullupLoading();
				}, 200);
			}, function(e) {
				mui.toast("获取位置失败");
				state.Lat = 0;
				state.Lon = 0;
				setState(state);
				setTimeout(function() {
					mui('#pullrefresh').pullRefresh().pullupLoading();
				}, 200);
			}, {
				timeout: 10000
			});
		
		
	});
});


window.addEventListener('updateindectDetails',function(e){
	document.body.querySelector('#p5-search-list-ul').innerHTML = "";
	page =1;
	offset = 1;
	mui('#pullrefresh').pullRefresh().pullupLoading();
		
})